package com.diagbot.aggregate;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.facade.NeoFacade;
import com.diagbot.util.ListUtil;
import com.diagbot.vo.NeoPushVO;
import io.github.lvyahui8.spring.annotation.DataConsumer;
import io.github.lvyahui8.spring.annotation.DataProvider;
import io.github.lvyahui8.spring.annotation.InvokeParameter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description:
 * @author: kwz
 * @time: 2020/10/22 15:24
 */
@Component
@Slf4j
public class PushDisAggregate {
    @Autowired
    private NeoFacade neoFacade;
    @DataProvider("pushAll")
    public List<String> getDis(
            @InvokeParameter("allDis") List<String> allDis,
            @InvokeParameter("pushVo") NeoPushVO pushVO,
            @InvokeParameter("lis") List<Lis> lises,
            @DataConsumer("pushDisBySymptomOrVital") List<String> disBySv,
            @DataConsumer("pushDisByLis") List<String> disByLis,
            @DataConsumer("pushDisByPr") List<String> disByPr
    ){
        List<String> allPushDis = new ArrayList<>();
        addDis(allPushDis,disBySv);
        addDis(allPushDis,disByLis);
        addDis(allPushDis,disByPr);
        return allPushDis;
    }

    private void addDis(List<String> allPushDis, List<String> disByLis) {
        if (ListUtil.isNotEmpty(disByLis)) {
            allPushDis.addAll(disByLis);
        }
    }

    @DataProvider("pushDisBySymptomOrVital")
    public List<String> pushDisBySym(@InvokeParameter("pushVo") NeoPushVO pushVO,@InvokeParameter("allDis") List<String> allDis) {
        neoFacade.pushDisBySymptomOrVital(pushVO,allDis);
        return allDis;
    }

    @DataProvider("pushDisByLis")
    public List<String> pushDisByL(@InvokeParameter("allDis") List<String> allDis,@InvokeParameter("lis") List<Lis> lises) {
        neoFacade.pushDisByLis(allDis,lises);
        return allDis;
    }

    @DataProvider("pushDisByPr")
    public List<String> pushDisByPacsRes(@InvokeParameter("pushVo") NeoPushVO pushVO,@InvokeParameter("allDis") List<String> allDis) {
        neoFacade.pushDisByPacs(pushVO,allDis);
        return allDis;
    }

}
