package com.diagbot.config;

import com.diagbot.facade.CacheFacade;
import com.diagbot.facade.NeoFacade;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

/**
 * @Description: 项目启动后初始化缓存
 * @author: gaodm
 * @time: 2020/5/13 11:20
 */
@Component //把类交给spring容器管理
@Order(100)  //使用order属性，设置该类在spring容器中的加载顺序
@Slf4j
public class CacheDeleteInit implements CommandLineRunner {

    @Autowired
    CacheFacade cacheFacade;
    @Autowired
    NeoFacade neoFacade;

    @Override
    public void run(String... args) throws Exception {
        // 服务启动清除redis缓存
        cacheFacade.clear();
        log.info("CDSS-CORE服务启动清除redis缓存成功！");

        cacheFacade.loadDrugTypeCache();
        log.info("CDSS-CORE服务启动加载药品类型对应关系缓存成功！");

        cacheFacade.getSymptomCache();
        log.info("CDSS-CORE服务启动加载图谱症状缓存成功！");

        cacheFacade.loadDiseaseTypeCache();
        log.info("CDSS-CORE服务启动加载疾病属性（性别、年龄、发病率）缓存成功！");

        cacheFacade.getSymptomNumCache();
        log.info("CDSS-CORE服务启动加载疾病对应的症状个数缓存成功！");

        /*neoFacade.getDisSexCache();
        log.info("CDSS-CORE服务启动加载图谱疾病对应性别信息缓存成功！");

        neoFacade.getDisAgeCache();
        log.info("CDSS-CORE服务启动加载图谱疾病对应年龄信息缓存成功！");

        neoFacade.getDisdistributionCache();
        log.info("CDSS-CORE服务启动加载图谱疾病对应发病率缓存成功！");*/

        log.info("CDSS-CORE初始化完成！");
    }
}
