package com.diagbot.config;

import org.neo4j.ogm.session.SessionFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.neo4j.repository.config.EnableNeo4jRepositories;
import org.springframework.data.neo4j.transaction.Neo4jTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * @Description:
 * @Author: Mark
 * @time: 2020/07/31 14:20
 */
@Configuration
@EnableNeo4jRepositories(basePackages = "com.diagbot.repository")
@EnableTransactionManagement
public class OgmConfigurer {

    @Value("${neo4j.data.URI}")
    private String uri;
    @Value("${neo4j.data.username")
    private String uname;
    @Value("${neo4j.data.password")
    private String passwd;


    @Bean
    public SessionFactory sessionFactory() {
        return new SessionFactory(configuration(), "com.diagbot.entity");
    }

    @Bean
    public org.neo4j.ogm.config.Configuration configuration() {
        org.neo4j.ogm.config.Configuration configuration =
                new org.neo4j.ogm.config.Configuration.Builder().
                        uri(uri).credentials(uname, passwd).build();
        return configuration;
    }

    @Bean
    public Neo4jTransactionManager transactionManager() throws Exception {
        return new Neo4jTransactionManager(sessionFactory());
    }


}
