package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.PacsNameClinicalFinding;
import com.diagbot.entity.relationship.YiBaoOperationNameClinicalFinding;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "临床表现")
public class ClinicalFinding extends BaseNode  {

	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Relationship(type = "辅助检查名称禁忌临床表现", direction = Relationship.INCOMING)
	private Set<PacsNameClinicalFinding> pacsNameClinicalFindings = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌临床表现", direction = Relationship.INCOMING)
	private Set<YiBaoOperationNameClinicalFinding> yiBaoOperationNameClinicalFindings = new HashSet<>();

}