package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "疾病")
public class Disease extends BaseNode  {


	@Relationship(type = "医保手术和操作名称禁忌疾病", direction = Relationship.INCOMING)
	private Set<YiBaoOperationNameDisease> yibaooperationnameDiseases = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌疾病", direction = Relationship.INCOMING)
	private Set<PacsNameDisease> pacsNameDiseases = new HashSet<>();

	@Relationship(type = "联合项目禁忌疾病", direction = Relationship.INCOMING)
	private Set<CombiOperationDisease> combioperationDiseases = new HashSet<>();

	@Relationship(type = "辅助检查名称子项目名称禁忌疾病", direction = Relationship.INCOMING)
	private Set<PacsNameSubNameDisease> pacsnamesubnameDiseases = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌疾病", direction = Relationship.INCOMING)
	private Set<PacsSubNameDisease> pacssubnameDiseases = new HashSet<>();

	@Relationship(type = "药品通用名称禁忌疾病", direction = Relationship.INCOMING)
	private Set<MedicineDisease> medicineDiseases = new HashSet<>();

}