package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.LisRemindGroup;
import com.diagbot.entity.relationship.LisRemindMedicine;
import com.diagbot.entity.relationship.LisRemindYiBaoDiseaseName;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "化验提醒指标")
public class LisRemind extends BaseNode  {

	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range=0;

	@Property(name = "结果")
    private String result;

	@Property(name = "实验室检查名称")
	private String lisname;

	@Relationship(type = "化验提醒指标相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<LisRemindYiBaoDiseaseName> lisReminddisease = new HashSet<>();

	@Relationship(type = "化验提醒指标相关禁忌人群", direction = Relationship.OUTGOING)
	private Set<LisRemindGroup> lisRemindgroup = new HashSet<>();

	@Relationship(type = "化验提醒指标相关药品通用名称", direction = Relationship.OUTGOING)
	private Set<LisRemindMedicine> lisRemindmedicines = new HashSet<>();

}