package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.LisNameLisSet;
import com.diagbot.entity.relationship.LisSetGender;
import com.diagbot.entity.relationship.LisSetGroup;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "实验室检查套餐名")
public class LisSet extends BaseNode  {

	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Relationship(type = "实验室检查套餐名禁忌性别", direction = Relationship.OUTGOING)
	private LisSetGender lisSetgender;

	@Relationship(type = "实验室检查套餐名禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<LisSetGroup> lisSetGroups = new HashSet<>();

	@Relationship(type = "实验室检查名称相关实验室检查套餐名", direction = Relationship.INCOMING)
	private Set<LisNameLisSet> lisnamelisSet = new HashSet<>();

}