package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "药物过敏原")
public class MedAllergen extends BaseNode  {

	@Property(name = "药品类型")
	private String medtype;

	@Relationship(type = "辅助检查名称禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<PacsNameMedAllergen> pacsMedAllergens = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<YiBaoOperationNameMedAllergen> yibaooperationnameMedAllergens = new HashSet<>();

	@Relationship(type = "辅助检查名称子项目名称禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<PacsNameSubNameMedAllergen> pacsnamesubnameMedAllergens = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<PacsSubNameMedAllergen> pacssubnameMedAllergens = new HashSet<>();

	@Relationship(type = "联合项目禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<CombiOperationMedAllergen> combioperationMedAllergens = new HashSet<>();

	@Relationship(type = "药品通用名称禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<MedicineMedAllergen> medicineMedAllergens = new HashSet<>();

	@Relationship(type = "药品注册名称禁忌药物过敏原", direction = Relationship.INCOMING)
	private Set<MedRegNameMedAllergen> medRegNameMedAllergens = new HashSet<>();
}