package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "药品代码通用名")
public class MedCodeName extends BaseNode  {


	@Property(name = "最小包装数量")
	private Double min_pack_num;

	@Property(name = "注册剂型")
	private String reg_JiXin;

	@Property(name = "药品本位码")
	private String BenWei_Code;

	@Property(name = "最小包装单位")
	private String min_pack_unit;

	@Property(name = "注册规格")
	private String reg_GuiGe;

	@Property(name = "包装材质")
	private String pack_CaiLiao;

	@Property(name = "药品企业")
	private String producer;

	@Property(name = "批准文号")
	private String license_num ;

	@Property(name = "最小制剂单位")
	private String min_prod_unit;

	@Relationship(type = "药品相关药品类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedClass> medCodeNameMedclasss = new HashSet<>();

	@Relationship(type = "药品相关药品注册名称", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedRegName> medCodeNameMedregnames = new HashSet<>();

	@Relationship(type = "药品相关药品通用名称", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedicine> medCodeNameMedicines = new HashSet<>();

	@Relationship(type = "药品相关药品化学物质类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedChemClass> medCodeNameMedchemclass = new HashSet<>();

	@Relationship(type = "药品相关药品药理学类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedYaoLiClass> medCodeNameMedyaoliclass = new HashSet<>();

	@Relationship(type = "药品相关药品治疗学类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedZhiLiaoClass> medCodeNameMedzhiliaoclass = new HashSet<>();

	@Relationship(type = "药品相关药品解剖学类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedJiePouClass> medCodeNameMedjiepouclass = new HashSet<>();

	@Relationship(type = "药品相关药品代码", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedCode> medCodeNameMedcodes = new HashSet<>();

	@Relationship(type = "药品相关药品商品名称", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedProdName> medCodeNameMedprodnames = new HashSet<>();

	@Relationship(type = "药品相关药品医保类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameMedYiBaoClass> medCodeNameMedyibaoclass = new HashSet<>();

	@Relationship(type = "药品相关注册名称", direction = Relationship.OUTGOING)
	private Set<MedCodeNameRegName> medCodeNameRegnames = new HashSet<>();

	@Relationship(type = "药品相关中成药方剂学大类", direction = Relationship.OUTGOING)
	private Set<MedCodeNameHerbFangJiCate> medCodeNameHerbfangjicates = new HashSet<>();

	@Relationship(type = "药品相关中成药方剂学类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameHerbFangJiClass> medCodeNameHerbfangjiclass = new HashSet<>();

	@Relationship(type = "药品相关中成药治疗学类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameHerbZhiLiaoClass> medCodeNameHerbzhiliaoclass = new HashSet<>();

	@Relationship(type = "药品相关中成药科室类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameHerbDeptClass> medCodeNameHerbdeptclass = new HashSet<>();

	@Relationship(type = "药品相关中成药医保类别", direction = Relationship.OUTGOING)
	private Set<MedCodeNameHerbYiBaoClass> medCodeNameHerbyibaoclass = new HashSet<>();

	@Relationship(type = "药品相关商品名称", direction = Relationship.OUTGOING)
	private Set<MedCodeNameProdName> medCodeNameProdnames = new HashSet<>();

}