package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "药品注册名称")
public class MedRegName extends BaseNode  {

	@Property(name = "药品高危级别")
	private String risklevel;

	@Property(name = "禁忌性别")
	private String conflict_gender;

	@Property(name = "禁忌给药途径")
	private String conflict_geiyao;

	@Relationship(type = "药品注册名称禁忌体征", direction = Relationship.OUTGOING)
	private Set<MedRegNameVital> medRegNameVital = new HashSet<>();

	@Relationship(type = "药品注册名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<MedRegNameGroup> medRegNameGroup = new HashSet<>();

	@Relationship(type = "药品注册名称禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<MedRegNameMedAllergen> medRegNameMedAllergens = new HashSet<>();

	@Relationship(type = "药品注册名称禁忌药品注册名称", direction = Relationship.OUTGOING)
	private Set<MedRegNameMedRegName> medRegNameMedregnames_out = new HashSet<>();

	@Relationship(type = "药品相关药品注册名称", direction = Relationship.INCOMING)
	private Set<MedCodeNameMedRegName> medcodenameMedRegNames = new HashSet<>();

	@Relationship(type = "药品注册名称禁忌药品注册名称", direction = Relationship.INCOMING)
	private Set<MedRegNameMedRegName> medregnameMedRegNames_in = new HashSet<>();

}