package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "药品通用名称")
public class Medicine extends BaseNode  {

	@Relationship(type = "药品相关药品通用名称", direction = Relationship.INCOMING)
	private Set<MedCodeNameMedicine> medcodenameMedicines = new HashSet<>();

	@Relationship(type = "化验提醒指标相关药品通用名称", direction = Relationship.INCOMING)
	private Set<LisRemindMedicine> lisremindMedicines = new HashSet<>();

	@Relationship(type = "药品通用名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<MedicineGroup> medicineGroup = new HashSet<>();

	@Relationship(type = "药品通用名称禁忌体征", direction = Relationship.OUTGOING)
	private Set<MedicineVital> medicineVital = new HashSet<>();

	@Relationship(type = "药品通用名称禁忌疾病", direction = Relationship.OUTGOING)
	private Set<MedicineDisease> medicineDisease = new HashSet<>();

	@Relationship(type = "药品通用名称禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<MedicineMedAllergen> medicineMedAllergens = new HashSet<>();


}