package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "辅助检查名称")
public class PacsName extends BaseNode  {


	@Relationship(type = "辅助检查名称包含辅助检查子项目名称", direction = Relationship.OUTGOING)
	private Set<PacsNamePacsSubName> pacsNamePacssubnames = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌性别", direction = Relationship.OUTGOING)
	private PacsNameGender pacsNameGender;

	@Relationship(type = "辅助检查名称禁忌临床表现", direction = Relationship.OUTGOING)
	private Set<PacsNameClinicalFinding> pacsNameClinicalfindings = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌体征", direction = Relationship.OUTGOING)
	private Set<PacsNameVital> pacsNameVitals = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌实验室检查", direction = Relationship.OUTGOING)
	private Set<PacsNameLis> pacsNameLis = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌辅助检查名称描述", direction = Relationship.OUTGOING)
	private Set<PacsNamePacsDescribe> pacsNamePacsdescribes = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<PacsNameGroup> pacsNameGroups = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌服用药品", direction = Relationship.OUTGOING)
	private Set<PacsNameOralMedicine> pacsNameOralmedicines = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<PacsNameMedAllergen> pacsNameMedallergens = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌疾病", direction = Relationship.OUTGOING)
	private Set<PacsNameDisease> pacsNameDiseases = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌过敏原", direction = Relationship.OUTGOING)
	private Set<PacsNameAllergen> pacsNameAllergens = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌禁忌医疗器械及物品", direction = Relationship.OUTGOING)
	private Set<PacsNameConflictDevice> pacsNameConflictdevices = new HashSet<>();

	@Relationship(type = "辅助检查名称相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<PacsNameYiBaoDiseaseName> pacsNameDisease = new HashSet<>();

	@Relationship(type = "辅助检查名称开单互斥辅助检查名称", direction = Relationship.OUTGOING)
	private Set<PacsNamePacsName> conflictPacsName_out = new HashSet<>();

	@Relationship(type = "辅助检查名称开单互斥辅助检查名称", direction = Relationship.INCOMING)
	private Set<PacsNamePacsName> conflictPacsName_in = new HashSet<>();

}