package com.diagbot.entity.node;

import com.diagbot.biz.push.entity.Pacs;
import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "辅助检查子项目名称")
public class PacsSubName extends BaseNode  {

	@Relationship(type = "辅助检查子项目名称禁忌性别", direction = Relationship.OUTGOING)
	private PacsSubNameGender pacsSubNameGender;

	@Relationship(type = "辅助检查子项目名称禁忌临床表现", direction = Relationship.OUTGOING)
	private Set<PacsSubNameClinicalFinding> pacsSubNameClinicalfindings = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌体征", direction = Relationship.OUTGOING)
	private Set<PacsSubNameVital> pacsSubNameVitals = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌实验室检查", direction = Relationship.OUTGOING)
	private Set<PacsSubNameLis> pacsSubNameLis = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌辅助检查名称描述", direction = Relationship.OUTGOING)
	private Set<PacsSubNamePacsDescribe> pacsSubNamePacsdescribes = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<PacsSubNameMedAllergen> pacsSubNameMedallergens = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<PacsSubNameGroup> pacsSubNameGroups = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌服用药品", direction = Relationship.OUTGOING)
	private Set<PacsSubNameOralMedicine> pacsSubNameOralmedicines = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌疾病", direction = Relationship.OUTGOING)
	private Set<PacsSubNameDisease> pacsSubNameDiseases = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌过敏原", direction = Relationship.OUTGOING)
	private Set<PacsSubNameAllergen> pacsSubNameAllergens = new HashSet<>();

	@Relationship(type = "辅助检查子项目名称禁忌禁忌医疗器械及物品", direction = Relationship.OUTGOING)
	private Set<PacsSubNameConflictDevice> pacsSubNameConflictdevices = new HashSet<>();

	@Relationship(type = "辅助检查名称包含辅助检查子项目名称", direction = Relationship.INCOMING)
	private Set<PacsNamePacsSubName> pacsNamePacsSubNames = new HashSet<>();

}