package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "体征")
public class Vital extends BaseNode  {


	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Property(name = "体征指标")
	private String vitalname;

	@Relationship(type = "辅助检查名称禁忌体征", direction = Relationship.INCOMING)
	private Set<PacsNameVital> pacsVitals = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌体征", direction = Relationship.INCOMING)
	private Set<YiBaoOperationNameVital> yibaooperationnameVitals = new HashSet<>();

	@Relationship(type = "体征相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<VitalYiBaoDiseaseName> vitalDisease = new HashSet<>();

	@Relationship(type = "药品注册名称禁忌体征", direction = Relationship.INCOMING)
	private Set<MedRegNameVital> medRegNameVitals = new HashSet<>();

}