package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "医保疾病名称")
public class YiBaoDiseaseName extends BaseNode  {

	@Property(name = "性别")
	private String gender;
	@Property(name = "年龄")
	private String age;

	@Relationship(type = "医保疾病名称相关医保ICD-10代码", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNameYiBaoICD_10Code> yiBaoDiseaseNameYibaoicd_10codes = new HashSet<>();

	@Relationship(type = "医保疾病名称相关国临疾病名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNameGuoLinDiseaseName> yiBaoDiseaseNameGuolindiseasenames = new HashSet<>();

	@Relationship(type = "医保疾病名称相关国临ICD-10代码", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNameGuoLinICD_10Code> yiBaoDiseaseNameGuolinicd_10codes = new HashSet<>();

	@Relationship(type = "医保疾病名称相关临床路径名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNamePathwayName> yiBaoDiseaseNamePathwaynames = new HashSet<>();

	@Relationship(type = "医保疾病名称相关症状", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNameSymptom> yiBaoDiseaseNameSymptoms = new HashSet<>();
	private Set<Symptom> Symptoms = new HashSet<>();

	@Relationship(type = "医保疾病名称相关体征", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNameVital> yiBaoDiseaseNameVitals = new HashSet<>();
	private Set<Vital> Vitals = new HashSet<>();

	@Relationship(type = "医保疾病名称相关化验套餐名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNameLisBigName> yiBaoDiseaseNameLisnames = new HashSet<>();
	private Set<LisBigName> Lisnames = new HashSet<>();

	@Relationship(type = "医保疾病名称相关辅助检查名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseNamePacsName> yiBaoDiseaseNamePacsnames = new HashSet<>();
	private Set<PacsName> Pacsnames = new HashSet<>();

	@Relationship(type = "实验室检查结果相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<LisResultYiBaoDiseaseName> lisresultYiBaoDiseaseNames = new HashSet<>();

	@Relationship(type = "化验提醒指标相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<LisRemindYiBaoDiseaseName> lisremindYiBaoDiseaseNames = new HashSet<>();

	@Relationship(type="建议输血提醒相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<TransfusionSuggestYiBaoDiseaseName> tfsuggestYiBaoDiseaseName = new HashSet<>();

}