package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import com.diagbot.entity.relationship.*;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "医保手术和操作名称")
public class YiBaoOperationName extends BaseNode  {

	// 3,4 属于高危
	@Property(name = "手术级别")
	private String opgrade;

	@Property(name = "拼音编码")
	private String pycode;

	@Property(name = "高危条件")
	private String highriskcond;

	@Relationship(type = "医保手术和操作名称相关国临ICD-9-CM3代码", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameGuoLinICD_9_CM3Code> guolinicd_9_cm3codes = new HashSet<>();

	@Relationship(type = "医保手术和操作名称相关国临手术和操作名称", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameGuoLinOperationName> guolinoperationnames = new HashSet<>();

	@Relationship(type = "医保手术和操作名称相关医保ICD-9-CM3代码", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameYiBaoICD_9_CM3Code> yibaoicd_9_cm3codes = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌性别", direction = Relationship.OUTGOING)
	private YiBaoOperationNameGender gender;

	@Relationship(type = "医保手术和操作名称禁忌临床表现", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameClinicalFinding> clinicalFindings = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌体征", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameVital> vitals = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌实验室检查", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameLis> liss = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌服用药品", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameOralMedicine> oralmeds = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌疾病", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameDisease> diseases = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameGroup> groups = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌辅助检查名称描述", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNamePacsDescribe> pacsdescs = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameMedAllergen> medallergens = new HashSet<>();

	@Relationship(type = "医保手术和操作名称禁忌禁忌医疗器械及物品", direction = Relationship.OUTGOING)
	private Set<YiBaoOperationNameConflictDevice> conflictdevices = new HashSet<>();

	@Relationship(type="建议输血提醒相关医保手术和操作名称", direction = Relationship.INCOMING)
	private Set<TransfusionSuggestYiBaoOperationName> tfsuggest = new HashSet<>();
}