package com.diagbot.entity.node.base;


import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.*;
import org.springframework.data.repository.query.Param;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 * @Description: 节点基础类
 * @author: MarkHuang
 * @time: 2020/3/23 15:30
 */
@Setter
@Getter
@NodeEntity(label = "")
public class BaseNode implements Serializable {
    @Id
    @GeneratedValue
    private Long id;

    @Labels
    private Set<String> labels;

    @Property(name = "name")
    private String name;

    @Property(name = "拼音编码")
    private String pycode;

    @Property(name = "静态知识")
    private String knowledge;

    // 静态知识标识, 0:没有静态知识, 1:有静态知识
    @Property(name = "静态知识标识")
    private Integer is_kl;

    // 节点的状态, 0:删除 1:正常
    @Property(name = "状态")
    private Integer status;

}
