package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @author zhoutg
 * @Description: 标准词转换
 * @date 2018年10月11日 下午3:33:22
 */

public enum RedisEnum implements KeyedNamed {

    drugType(1, "drugType:"),
    symptomVitalType(3, "symptomVitalType:"),
    symptomNumType(4, "symptomNumType:"),
    diseaseType(2, "diseaseType:");

    @Setter
    private int key;

    @Setter
    private String name;

    RedisEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static RedisEnum getEnum(int key) {
        for (RedisEnum item : RedisEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        RedisEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
