package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import com.diagbot.repository.Constants;
import lombok.Setter;

/**
 * @Description: 静态信息类型
 * @author: gaodm
 * @time: 2020/9/3 20:16
 */
public enum StaticTypeEnum implements KeyedNamed {

    DIS(1, Constants.yibaodisease),
    DRUG(2, Constants.medicine),
    LISSET(3, Constants.lissetname),
    LIS(4, Constants.lisname),
    PACS(5, Constants.pacsname),
    OPT(6, Constants.yibaoopname),
    PACSSUBNAME(7, Constants.pacssubname);

    @Setter
    private int key;

    @Setter
    private String name;

    StaticTypeEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static StaticTypeEnum getEnum(int key) {
        for (StaticTypeEnum item : StaticTypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        StaticTypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
