package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @author zhoutg
 * @Description: 类型枚举
 * @date 2018年10月11日 下午3:33:22
 */

public enum TypeEnum implements KeyedNamed {

    lis(1, "化验"),
    pacs(2, "辅检"),
    disease(3, "诊断"),
    drug(4, "药品"),
    clinical(5, "临床表现"),
    operation(6, "手术"),
    vital(7, "查体"),
    transfusion(8, "输血"),
    age(9,"年龄");

    @Setter
    private int key;

    @Setter
    private String name;

    TypeEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static TypeEnum getEnum(int key) {
        for (TypeEnum item : TypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static TypeEnum getEnum(String value) {
        for (TypeEnum item : TypeEnum.values()) {
            if (item.getName().equals(value)) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        TypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
