package com.diagbot.facade;

import com.diagbot.dto.CriticalNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.CriticalProcess;
import com.diagbot.vo.CriticalNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 危急值facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class CriticalFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    CriticalProcess criticalProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 危急值提示
     * @param
     * @return
     */
    public void criticalFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 危急值图谱接口调用
        CriticalNeoVO criticalNeoVOs = fillCriticalNeo(wordCrfDTO);
        List<CriticalNeoDTO> criticalNeoDTOList = neoFacade.getCritialNeo(criticalNeoVOs);

        criticalProcess.process(criticalNeoDTOList, wordCrfDTO, res);

        // 结果去重处理
        commonFacade.dealMsg(res.getCriticalValList());
    }




    public CriticalNeoVO fillCriticalNeo(WordCrfDTO wordCrfDTO) {
        CriticalNeoVO criticalNeoVO = new CriticalNeoVO();

        criticalNeoVO.setAge(wordCrfDTO.getAgeNum());
        criticalNeoVO.setSex(wordCrfDTO.getSex());
        criticalNeoVO.setVitalLabel(wordCrfDTO.getVitalLabel());
        criticalNeoVO.setLis(wordCrfDTO.getLis());
        criticalNeoVO.setPacsLabel(wordCrfDTO.getPacsLabel());


        return criticalNeoVO;
    }
}
