package com.diagbot.facade;

import com.diagbot.repository.BaseNodeRepository;
import com.diagbot.vo.HasStaticKnowledgeVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/8/25 14:13
 */
@Component
public class StaticKnowledgeFacade {

    /**
     * 更新是否包含静态知识状态
     *
     * @param hasStaticKnowledgeVO
     * @return
     */
    @Autowired
    BaseNodeRepository nodeRepository;
    public Boolean updateHasInfoStatus(HasStaticKnowledgeVO hasStaticKnowledgeVO) {
        @NotBlank(message = "请输入术语类型") String type = hasStaticKnowledgeVO.getType();
        @NotBlank(message = "请输入标准术语名称") String name = hasStaticKnowledgeVO.getName();
        @NotNull(message = "请输入是否有静态信息（0-无，1-有）") Integer hasInfo = hasStaticKnowledgeVO.getHasInfo();
        nodeRepository.updateStaticKnowledgeSign(type,name,hasInfo);
        /*switch (type){
            case "":
                System.out.println();
                break;
            case "ww":
                System.out.println();
                break;
        }*/
        return true;
    }
}
