package com.diagbot.process;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.enums.TypeEnum;
import com.diagbot.rule.CommonRule;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 高风险总入口
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class HighRiskProcess {

    @Autowired
    CommonRule commonRule;

    /**
     * 处理业务
     *
     * @param highRiskNeoDTOList
     * @param res
     */
    public void process(List<HighRiskNeoDTO> highRiskNeoDTOList, IndicationDTO res, WordCrfDTO wordCrfDTO) {
        List<BillMsg> highRiskList = new ArrayList<>();
        CommonRule commonRule = new CommonRule();
        for (HighRiskNeoDTO highRiskNeoDTO : highRiskNeoDTOList) {
            System.out.println(highRiskNeoDTO);
            String type = highRiskNeoDTO.getType();
            if (highRiskNeoDTO.getIsHighrisk() == true) {
                commonRule.highRisk(highRiskNeoDTO, highRiskList);
            } else {
                // 复杂情况高危手术
                if (TypeEnum.operation.getName().equals(type)) {
                    List<NodeNeoDTO> factor = highRiskNeoDTO.getFactor();
                    for (NodeNeoDTO nodeNeoDTO : factor) {
                        switch (TypeEnum.getEnum(nodeNeoDTO.getTermtype())) {
                            case disease:
                            case lis:
                            case pacs:
                            case vital:
                            case age:
                                commonRule.highRiskComplex(nodeNeoDTO, highRiskList, highRiskNeoDTO);
                                break;
                        }
                    }
                }
            }
        }
        res.setHighRiskList(highRiskList);
    }
}
