package com.diagbot.repository;

import com.diagbot.entity.node.PacsSubName;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface PacsSubNameRepository extends Neo4jRepository<PacsSubName, Long> {

    List<PacsSubName> findByNameIs(String name);

    List<PacsSubName> findByNameContaining(String name);

    List<PacsSubName> findByNameIn(List<String> names);

    @Query("MATCH (n:`辅助检查子项目名称`) WHERE toLower(n.`name`) = toLower($name) \n" +
            "OR toLower(n.`拼音编码`) = toLower($pycode)  \n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n" +
            "union\n" +
            "MATCH (n:`辅助检查子项目名称`) WHERE toLower(n.`name`) starts with toLower($name) \n" +
            "OR toLower(n.`拼音编码`) starts with toLower($pycode)  \n" +
            "WITH n SKIP 0 LIMIT $size\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n" +
            "union\n" +
            "MATCH (n:`辅助检查子项目名称`) WHERE toLower(n.`name`) CONTAINS toLower($name) \n" +
            "OR toLower(n.`拼音编码`) CONTAINS toLower($pycode)  \n" +
            "WITH n SKIP 0 LIMIT $size\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    List<PacsSubName> index(@Param("name") String name, @Param("pycode") String pycode, @Param("size") Integer size);
}

