package com.diagbot.repository;

import com.diagbot.entity.node.Symptom;
import com.diagbot.util.ListUtil;

import java.util.ArrayList;
import java.util.List;

public class SymptomNameNode {

    /**
     * 获取症状名称列表
     */
    public List<String> getSymptomList(String name, Integer size, SymptomNameRepository symptomNameRepository, BaseNodeRepository baseNodeRepository) {
        List<String> symplt = new ArrayList<>();
        if (null == size) {
            size = 100;
        }

        List<Symptom> symplist = symptomNameRepository.index(name, name, size);

        if (ListUtil.isNotEmpty(symplist) && symplist.size() > size) {
            symplist = symplist.subList(0, size);
        }

        for (Symptom symptom : symplist) {
            symplt.add(symptom.getName());
        }
        return symplt;
    }



    /**
     * 获取症状名称列表
     */
    public List<String> getSymptoms(String name, Integer size, SymptomNameRepository symptomNameRepository) {
        List<String> symplt = new ArrayList<>();
        if (null == size || size == 0) {
            size = Constants.termsize;
        }

        symplt = symptomNameRepository.getSymptomNames(size);

        return symplt;
    }
}

