package com.diagbot.repository;


import com.diagbot.dto.OtherTipTransfusionNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.entity.node.TransfusionSuggest;
import com.diagbot.biz.push.entity.Item;
import com.diagbot.biz.push.entity.Lis;
import com.diagbot.entity.node.YiBaoDiseaseName;
import com.diagbot.entity.node.YiBaoOperationName;
import com.diagbot.entity.relationship.TransfusionSuggestYiBaoDiseaseName;
import com.diagbot.entity.relationship.TransfusionSuggestYiBaoOperationName;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;
import com.diagbot.util.StringUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TransfusionSuggestNode {

	public List<OtherTipTransfusionNeoDTO> findSuggest(List<TransfusionSuggest> transfusionSuggests, WordCrfDTO wordCrfDTO) {

		List<OtherTipTransfusionNeoDTO> ottfNeoDTOs = new ArrayList<>();

		OtherTipTransfusionNeoDTO otherTipTfNeoDTO = new OtherTipTransfusionNeoDTO();

		Item item;
		List<String> diseases = new ArrayList<>();
		List<String> surgery = new ArrayList<>();
		Map<String, Lis> lismap = new HashMap<>();
		String disname, surgname, lisname, tfname;
		Lis lisresult;

		for (Item dg : wordCrfDTO.getDiag()) {
			diseases.add(dg.getUniqueName());
		}

		for (Item op : wordCrfDTO.getOperation()) {
			surgery.add(op.getUniqueName());
		}

		for (Lis lisitem : wordCrfDTO.getLis()) {
			lismap.put(lisitem.getUniqueName(), lisitem);
		}

		for (TransfusionSuggest tf : transfusionSuggests) {

			tfname = tf.getTransfusion_type();
			lisname = "";
			disname = "";
			surgname = "";
			lisresult = null;
			Double val;

			if (tf.getNode_label().equals(Constants.lisname)) {
				lisname = tf.getIndex_name();
				lisresult = lismap.get(lisname);
				if (lisresult!=null && null != lisresult.getValue()) {
					val = lisresult.getValue();
					if (tf.getRange() == 0) {
						if (null == tf.getMinval() && null == tf.getMaxval()) {
							lisresult = null;
						} else if (null == tf.getMinval() && val > tf.getMaxval()) {
							lisresult = null;
						} else if (null == tf.getMaxval() && val < tf.getMinval()) {
							lisresult = null;
						} else if (null != tf.getMinval() && null != tf.getMaxval() &&
								(val > tf.getMaxval() || val < tf.getMinval())) {
							lisresult = null;
						}
					} else if (tf.getRange() == 1) {
						if (null == tf.getMinval() && null == tf.getMaxval()) {
							lisresult = null;
						} else if (null != tf.getMaxval() && val < tf.getMaxval()) {
							lisresult = null;
						} else if (null != tf.getMinval() && val > tf.getMinval()) {
							lisresult = null;
						}
					}
				}
				else {
					lisname = "";
					lisresult = null;
				}
			}

			if (tf.getTransfusionSuggestDiseases().size()>0) {
				for (TransfusionSuggestYiBaoDiseaseName tfDisease : tf.getTransfusionSuggestDiseases()) {
					if (NeoUtil.isExist(tfDisease)) {
						if (NeoUtil.isExist(tfDisease.getYiBaoDiseaseName())) {
							YiBaoDiseaseName ybdisease = tfDisease.getYiBaoDiseaseName();
							disname = ybdisease.getName();
						}
					}
				}
			}

			if (tf.getTransfusionSuggestOperations().size()>0) {
				for (TransfusionSuggestYiBaoOperationName tfOperation : tf.getTransfusionSuggestOperations()) {
					if (NeoUtil.isExist(tfOperation)) {
						if (NeoUtil.isExist(tfOperation.getYiBaoOperationName())) {
							YiBaoOperationName yboperation = tfOperation.getYiBaoOperationName();
							surgname = yboperation.getName();
						}
					}
				}
			}


			otherTipTfNeoDTO = null;
			boolean proceed = true;
			if (StringUtil.isNotBlank(lisname) || StringUtil.isNotBlank(disname) || StringUtil.isNotBlank(surgname)) {

				if (StringUtil.isNotBlank(lisname) && null != lisresult && proceed) {
					otherTipTfNeoDTO = new OtherTipTransfusionNeoDTO();

					otherTipTfNeoDTO.getLisList().add(lisresult);
				} else {
					proceed = false;
					otherTipTfNeoDTO = null;
				}

				if (StringUtil.isNotBlank(surgname) && proceed) {
					if (ListUtil.isNotEmpty(surgery) && surgery.contains(surgname)) {
						if (null == otherTipTfNeoDTO) {
							otherTipTfNeoDTO = new OtherTipTransfusionNeoDTO();
						}
						item = new Item();
						item.setName(surgname);
						item.setUniqueName(surgname);

						otherTipTfNeoDTO.getOperation().add(item);
					} else {
						proceed = false;
						otherTipTfNeoDTO = null;
					}
				}


				if (StringUtil.isNotBlank(disname) && proceed) {

					if (ListUtil.isNotEmpty(diseases) && diseases.contains(disname)) {
						if (null == otherTipTfNeoDTO) {
							otherTipTfNeoDTO = new OtherTipTransfusionNeoDTO();
						}
						item = new Item();
						item.setName(disname);
						item.setUniqueName(disname);

						otherTipTfNeoDTO.getDiag().add(item);
					} else {
						otherTipTfNeoDTO = null;
					}
				}


				if (otherTipTfNeoDTO != null) {
					otherTipTfNeoDTO.setName(tfname);
					ottfNeoDTOs.add(otherTipTfNeoDTO);
				}
			}

		}

		return ottfNeoDTOs;
	}


	/**
	 * 获取建议输血提醒列表
	 */
	public List<OtherTipTransfusionNeoDTO> getTransfusionSuggest(WordCrfDTO wordCrfDTO, TransfusionSuggestRepository transfusionSugRepository) {

		List<OtherTipTransfusionNeoDTO> tfNeoDTOs = new ArrayList<>();

		List<TransfusionSuggest> tslist;

		tslist = transfusionSugRepository.findByNameContaining("");

		if (ListUtil.isNotEmpty(tslist)) {
			tfNeoDTOs = findSuggest(tslist, wordCrfDTO);
		}

		return tfNeoDTOs;
	}
}

