package com.diagbot.repository;

import com.diagbot.entity.node.TransfusionSuggest;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface TransfusionSuggestRepository extends Neo4jRepository<TransfusionSuggest, Long> {

    List<TransfusionSuggest> findByNameIs(String name);

    List<TransfusionSuggest> findByNameContaining(String name);

    @Query("MATCH (n:建议输血提醒) where n.输注类型 contains {name} return distinct(n.输注类型)")
    List<String> findTransfusionByName(@Param("name") String name);

    @Query("MATCH (n:建议输血提醒指标) where n.输注类型 contains {name} return n")
    List<TransfusionSuggest> findByTransfusionName(@Param("name") String name);

}

