package com.diagbot.repository;

import com.diagbot.entity.node.Vital;
import com.diagbot.util.ListUtil;

import java.util.ArrayList;
import java.util.List;

public class VitalNameNode {

    /**
     * 获取体征名称列表
     */
    public List<String> getVitalList(String name, Integer size, VitalRepository vitalRepository) {
        List<String> vitallt = new ArrayList<>();
        if (null == size) {
            size = 100;
        }

        List<Vital> vitallist = vitalRepository.index(name, name, size);

        if (ListUtil.isNotEmpty(vitallist) && vitallist.size() > size) {
            vitallist = vitallist.subList(0, size);
        }

        for (Vital vital : vitallist) {
            vitallt.add(vital.getName());
        }
        return vitallt;
    }



    /**
     * 获取体征名称列表
     */
    public List<String> getVitals(String name, Integer size, VitalRepository vitalRepository) {
        List<String> vitallt = new ArrayList<>();
        if (null == size || size == 0) {
            size = Constants.termsize;
        }

        vitallt = vitalRepository.getVitalNames(size);

        return vitallt;
    }
}

