package com.diagbot.repository;

import com.diagbot.dto.DiseaseInfoDTO;
import com.diagbot.dto.NeoPushDTO;
import com.diagbot.dto.PushBaseDTO;
import com.diagbot.entity.node.*;
import com.diagbot.entity.relationship.YiBaoDiseaseNameGuoLinDiseaseName;
import com.diagbot.entity.relationship.YiBaoDiseaseNameGuoLinICD_10Code;
import com.diagbot.entity.relationship.YiBaoDiseaseNamePathwayName;
import com.diagbot.entity.relationship.YiBaoDiseaseNameYiBaoICD_10Code;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;
import com.diagbot.vo.NeoPushVO;

import java.util.*;
import java.util.stream.Collectors;

public class YiBaoDiseaseNode {
	public NeoPushDTO YiBaoDiseasetoDiseaseDTO(YiBaoDiseaseName disease, NeoPushVO neoPushVO) {

		NeoPushDTO pushDTO = new NeoPushDTO();
		PushBaseDTO pushBaseDTO;

		int gender = neoPushVO.getSex();
		double age = neoPushVO.getAgeNum();


		if (NeoUtil.matchBasic(disease, gender, age)) {

			pushBaseDTO = new PushBaseDTO();
			pushBaseDTO.setName(disease.getName());
			pushDTO.setDisease(pushBaseDTO);
			pushDTO.setSymptoms(disease.getSymptoms().stream().collect(Collectors.toMap(Symptom::getName, Symptom::getId, (e1, e2) -> e2))
					.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByValue()))
					.map(x -> NeoUtil.updatePushInfo(x.getKey())).collect(Collectors.toList()));

			pushDTO.setVitals(disease.getVitals().stream().collect(Collectors.toMap(Vital::getName, Vital::getId, (e1, e2) -> e2))
					.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByValue()))
					.map(x -> NeoUtil.updatePushInfo(x.getKey())).collect(Collectors.toList()));

			pushDTO.setLis(disease.getLisnames().stream().collect(Collectors.toMap(LisBigName::getName, LisBigName::getId, (e1, e2) -> e2))
					.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByValue()))
					.map(x -> NeoUtil.updatePushInfo(x.getKey())).collect(Collectors.toList()));

			pushDTO.setPacs(disease.getPacsnames().stream().collect(Collectors.toMap(PacsName::getName, PacsName::getId, (e1, e2) -> e2))
					.entrySet().stream().sorted(Collections.reverseOrder(Map.Entry.comparingByValue()))
					.map(x -> NeoUtil.updatePushInfo(x.getKey())).collect(Collectors.toList()));




		/*
		CureRate curerate = disease.getCurerate();
		if (null != curerate) {
			NeoUtil.updateNodeInfo(curerate.getName(), null, null, null);
		}

		TreatCycle treatcycle = disease.getTreatcycle();
		if (null != treatcycle) {
			NeoUtil.updateNodeInfo(treatcycle.getName(), null, null, null);
		}

		Set<Infection> infections = disease.getInfections();
		for (Infection infection : infections) {
			NeoUtil.updateNodeInfo(infection.getName(), null, null, null);
		}

		Set<Group> groups = disease.getGroups();
		for (Group group : groups) {
			NeoUtil.updateNodeInfo(group.getName(), null, null, null);
		}

		Set<Alias> aliass = disease.getAlias();
		for (Alias alias : aliass) {
			NeoUtil.updateNodeInfo(alias.getName(), null, null, null);
		}


		Set<Vital> vitals = disease.getVitals();
		for (Vital vital : vitals) {
			String name = vital.getName();
			pushDTO.getVital().add(NeoUtil.updatePushInfo(name));
		}


		Set<Dept> depts = disease.getDepts();
		for (Dept dept : depts) {
			NeoUtil.updateNodeInfo(dept.getName(), null, null, null);
		}


		Set<Symptom> symptoms = disease.getSymptoms();
		for (Symptom symptom : symptoms) {
            pushDTO.getSymptom().add(NeoUtil.updatePushInfo(symptom.getName()));
		}


		Set<Situation> situations = disease.getSituations();
		for (Situation situation : situations) {
			NeoUtil.updateNodeInfo(situation.getName(), null, null, null);
		}

		Code code = disease.getCode();
		if (null != code) {
			NeoUtil.updateNodeInfo(code.getName(), null, null, null);
		}

		Set<Dept> stddepts = disease.getDepts();
		for (Dept stddept : stddepts) {
			NeoUtil.updateNodeInfo(stddept.getName(), null, null, null);
		}


		Set<Complication> complications = disease.getComplications();
		for (Complication complication : complications) {
			pushDTO.getComplications().add(NeoUtil.updatePushInfo(complication.getName()));
		}

		Set<PACS> pacss = disease.getPacs();
		for (PACS pacs : pacss) {
			String name = pacs.getName();
			pushDTO.getPacs().add(NeoUtil.updatePushInfo(name));
		}

		Set<Medicine> medicines = disease.getMedicines();
		for (Medicine medicine : medicines) {
			pushDTO.getMedicines().add(NeoUtil.updatePushInfo(medicine.getName()));
		}


		Set<Cause> causes = disease.getCauses();
		for (Cause cause : causes) {
			NeoUtil.updateNodeInfo(cause.getName(), null, null, null);
		}


		Set<Disease> diff_diseases = disease.getDiff_diseases();
		List<PushBaseDTO> pushBaseDTOs = new ArrayList<>();
		for (Disease diff_disease : diff_diseases) {
			pushBaseDTOs.add(NeoUtil.updatePushInfo(diff_disease.getName()));
		}
		Map<String, List<PushBaseDTO>> dis = new HashMap<>();
		dis.put("鉴别诊断", pushBaseDTOs);
		pushDTO.setDis(dis);

		Set<Operation> operations = disease.getOperations();
		for (Operation operation : operations) {
			pushDTO.getOperations().add(NeoUtil.updatePushInfo(operation.getName()));
		}


		Set<Pathogen> pathogens = disease.getPathogens();
		for (Pathogen pathogen : pathogens) {
			NeoUtil.updateNodeInfo(pathogen.getName(), null, null, null);
		}

		Set<Heredity> hereditys = disease.getHereditys();
		for (Heredity heredity : hereditys) {
			NeoUtil.updateNodeInfo(heredity.getName(), null, null, null);
		}

		Set<Treatment> treatments = disease.getTreatments();
		for (Treatment treatment : treatments) {
			NeoUtil.updateNodeInfo(treatment.getName(), null, null, null);
		}

		Set<DiseaseType> diseasetypes = disease.getDiseasetypes();
		for (DiseaseType diseasetype : diseasetypes) {
			NeoUtil.updateNodeInfo(diseasetype.getName(), null, null, null);
		}

		Set<Complication> localcompls = disease.getLocalcompls();
		for (Complication localcompl : localcompls) {
			NeoUtil.updateNodeInfo(localcompl.getName(), null, null, null);
		}

		Set<Complication> generalcompls = disease.getGeneralcompls();
		for (Complication generalcompl : generalcompls) {
			NeoUtil.updateNodeInfo(generalcompl.getName(), null, null, null);
		}


		Set<LIS> liss = disease.getLiss_dis();
		for (LIS lis : liss) {
			pushDTO.getLis().add(NeoUtil.updatePushInfo(lis.getName()));
		}


		Set<PACS> pacs_disease= disease.getPacs_disease();
		for (PACS pacs : pacs_disease) {
			String name = pacs.getName();
			String min = pacs.getMinval();
			String max = pacs.getMaxval();
			String unit = pacs.getUnit();
			NeoUtil.updateNodeInfo(name, min, max, unit);
		}

		Medicine_Code medicine_code = disease.getMedicine_code();
		if (null != medicine_code) {
			NeoUtil.updateNodeInfo(medicine_code.getName(), null, null, null);
		}
		*/

			Set<YiBaoDiseaseNameYiBaoICD_10Code> yiBaoICD10Codes = disease.getYiBaoDiseaseNameYibaoicd_10codes();
			for (YiBaoDiseaseNameYiBaoICD_10Code code : yiBaoICD10Codes) {
				if (NeoUtil.isExist(code)) {
					if (NeoUtil.isExist(code.getYiBaoICD_10Code())) {
						pushBaseDTO = new PushBaseDTO();
						pushBaseDTO.setName(code.getYiBaoICD_10Code().getName());
					}
				}
			}


			Set<YiBaoDiseaseNameGuoLinICD_10Code> guoLinICD10Codes = disease.getYiBaoDiseaseNameGuolinicd_10codes();
			for (YiBaoDiseaseNameGuoLinICD_10Code code : guoLinICD10Codes) {
				if (NeoUtil.isExist(code)) {
					if (NeoUtil.isExist(code.getGuoLinICD_10Code())) {
						pushBaseDTO = new PushBaseDTO();
						pushBaseDTO.setName(code.getGuoLinICD_10Code().getName());
					}
				}
			}

			Set<YiBaoDiseaseNameGuoLinDiseaseName> guoLinDiseaseNames = disease.getYiBaoDiseaseNameGuolindiseasenames();
			for (YiBaoDiseaseNameGuoLinDiseaseName glname : guoLinDiseaseNames) {
				if (NeoUtil.isExist(glname)) {
					if (NeoUtil.isExist(glname.getGuoLinDiseaseName())) {
						pushBaseDTO = new PushBaseDTO();
						pushBaseDTO.setName(glname.getGuoLinDiseaseName().getName());
					}
				}
			}

			Set<YiBaoDiseaseNamePathwayName> pathwayNames = disease.getYiBaoDiseaseNamePathwaynames();
			for (YiBaoDiseaseNamePathwayName pwname : pathwayNames) {
				if (NeoUtil.isExist(pwname)) {
					if (NeoUtil.isExist(pwname.getPathwayName())) {
						pushBaseDTO = new PushBaseDTO();
						pushBaseDTO.setName(pwname.getPathwayName().getName());
					}
				}
			}

		}


		return pushDTO;
	}


	private boolean matchBasic(YiBaoDiseaseName disease, int gender_code, int age) {
		boolean match = true;

		String gender = null;

		if (gender_code == 1) {
			gender = "男";
		} else if (gender_code == 2) {
			gender = "女";
		}

		if (null != disease.getGender() && gender != null) {
			if (!disease.getGender().contains(gender)) {
				match = false;
			}
		}

		//		if (null!=disease.getAge()) {
		//			int min = disease.getAge().getMinval();
		//			int max = disease.getAge().getMaxval();
		//			if (age < min || age > max) {
		//				match = false;
		//			}
		//		}

		return match;
	}


	/**
	 * 获取疾病名称列表
	 */
	public List<DiseaseInfoDTO> getDiseaseNameList(String name, Integer size, YiBaoDiseaseNameRepository diseaseRepository, BaseNodeRepository baseNodeRepository) {
		String icdname;

		List<String> dislist = new ArrayList<>();
		List<DiseaseInfoDTO> diseaseInfoDTOList = new ArrayList<>();
		if (null == size) {
			size = 100;
		}

		List<YiBaoDiseaseName> diseases = diseaseRepository.index(name, name, size);

		if (ListUtil.isNotEmpty(diseases) && diseases.size() > size) {
			diseases = diseases.subList(0, size);
		}

		for (YiBaoDiseaseName dis : diseases) {
			icdname = dis.getName();
			if (!dislist.contains(icdname)) {
				dislist.add(icdname);
				DiseaseInfoDTO diseaseInfoDTO = new DiseaseInfoDTO();
				diseaseInfoDTO.setName(icdname);
				if (!dis.getYiBaoDiseaseNameGuolinicd_10codes().isEmpty()) {
					diseaseInfoDTO.setIcd10Code(dis.getYiBaoDiseaseNameGuolinicd_10codes().iterator().next().getGuoLinICD_10Code().getName());
				}
				diseaseInfoDTOList.add(diseaseInfoDTO);
			}
		}

		return diseaseInfoDTOList;
	}


	/**
	 * 获取疾病名称列表
	 */
	public List<DiseaseInfoDTO> getDiseaseNames(String name, Integer size, YiBaoDiseaseNameRepository diseaseRepository) {

		List<DiseaseInfoDTO> diseaselist = new ArrayList<>();
		DiseaseInfoDTO diseaseInfoDTO;

		if (null == size || size == 0) {
			size = Constants.termsize;
		}

		List<String> diseases = diseaseRepository.getDiseaseNames(size);

		for (String disease : diseases) {
			diseaseInfoDTO = new DiseaseInfoDTO();
			diseaseInfoDTO.setName(disease);
			diseaselist.add(diseaseInfoDTO);
		}

		return diseaselist;
	}

}

