package com.diagbot.repository;


import com.alibaba.fastjson.JSONObject;
import com.diagbot.biz.push.entity.Item;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.OperationBillNeoDTO;
import com.diagbot.dto.OperationInfoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.entity.node.ClinicalFinding;
import com.diagbot.entity.node.ConflictDevice;
import com.diagbot.entity.node.Disease;
import com.diagbot.entity.node.Gender;
import com.diagbot.entity.node.Group;
import com.diagbot.entity.node.Lis;
import com.diagbot.entity.node.MedAllergen;
import com.diagbot.entity.node.OralMedicine;
import com.diagbot.entity.node.PacsDescribe;
import com.diagbot.entity.node.Vital;
import com.diagbot.entity.node.YiBaoOperationName;
import com.diagbot.entity.relationship.*;
import com.diagbot.enums.TypeEnum;
import com.diagbot.model.label.PacsLabel;
import com.diagbot.model.label.VitalLabel;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;
import com.diagbot.util.StringUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class YiBaoOperationNameNode {


    public OperationBillNeoDTO YiBaoOperationtoOperationDTO(YiBaoOperationName operation) {
        OperationBillNeoDTO opBillNeoDTO = new OperationBillNeoDTO();
        NodeInfo nodeInfo;

        YiBaoOperationNameGender yiBaoOperationNameGender = operation.getGender();
        if (NeoUtil.isExist(yiBaoOperationNameGender)) {
            if (NeoUtil.isExist(yiBaoOperationNameGender.getGender())) {
                Gender gender = yiBaoOperationNameGender.getGender();
                nodeInfo = new NodeInfo();
                nodeInfo.setName(gender.getName());
                nodeInfo.setTypeval(Constants.gender);
                opBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }

        Set<YiBaoOperationNameClinicalFinding> yibaoOperationNameclinicalfindings = operation.getClinicalFindings();
        for (YiBaoOperationNameClinicalFinding yiBaoOperationNameclinicalfinding : yibaoOperationNameclinicalfindings) {
            if (NeoUtil.isExist(yiBaoOperationNameclinicalfinding)) {
                if (NeoUtil.isExist(yiBaoOperationNameclinicalfinding.getClinicalFinding())) {
                    ClinicalFinding clinicalfinding = yiBaoOperationNameclinicalfinding.getClinicalFinding();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(clinicalfinding.getName());
                    nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMinval()));
                    nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMaxval()));
                    nodeInfo.setUnit(clinicalfinding.getUnit());
                    nodeInfo.setRange(clinicalfinding.getRange());
                    nodeInfo.setTypeval(Constants.clinicalfinding);
                    opBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameVital> yiBaoOperationNamevitals = operation.getVitals();
        for (YiBaoOperationNameVital yiBaoOperationNamevital : yiBaoOperationNamevitals) {
            if (NeoUtil.isExist(yiBaoOperationNamevital)) {
                if (NeoUtil.isExist(yiBaoOperationNamevital.getVital())) {
                    Vital vital = yiBaoOperationNamevital.getVital();
                    nodeInfo = new NodeInfo();
                    String name = vital.getName();
                    nodeInfo.setName(name);
                    nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(vital.getMinval()));
                    nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(vital.getMaxval()));
                    nodeInfo.setUnit(vital.getUnit());
                    nodeInfo.setRange(vital.getRange());
                    nodeInfo.setTypeval(Constants.vital);
                    opBillNeoDTO.getVitals().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameLis> yiBaoOperationNameLisSet = operation.getLiss();
        for (YiBaoOperationNameLis yiBaoOperationNameLis : yiBaoOperationNameLisSet) {
            if (NeoUtil.isExist(yiBaoOperationNameLis)) {
                if (NeoUtil.isExist(yiBaoOperationNameLis.getLis())) {
                    Lis lis = yiBaoOperationNameLis.getLis();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(lis.getName());
                    nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(lis.getMinval()));
                    nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(lis.getMaxval()));
                    nodeInfo.setUnit(lis.getUnit());
                    nodeInfo.setRange(lis.getRange());
                    nodeInfo.setTypeval(Constants.lis);
                    opBillNeoDTO.getLis().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameOralMedicine> yiBaoOperationNameOralMeds= operation.getOralmeds();
        for (YiBaoOperationNameOralMedicine yiBaoOperationNameOralMed : yiBaoOperationNameOralMeds) {
            if (NeoUtil.isExist(yiBaoOperationNameOralMed)) {
                if (NeoUtil.isExist(yiBaoOperationNameOralMed.getOralMedicine())) {
                    OralMedicine conflict_oralmed = yiBaoOperationNameOralMed.getOralMedicine();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(conflict_oralmed.getName());
                    nodeInfo.setTypeval(Constants.yaoping);
                    opBillNeoDTO.getOralmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameDisease> yiBaoOperationNameDiseases = operation.getDiseases();
        for (YiBaoOperationNameDisease yiBaoOperationNameDisease : yiBaoOperationNameDiseases) {
            if (NeoUtil.isExist(yiBaoOperationNameDisease)) {
                if (NeoUtil.isExist(yiBaoOperationNameDisease.getDisease())) {
                    Disease disease = yiBaoOperationNameDisease.getDisease();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(disease.getName());
                    nodeInfo.setTypeval(Constants.disease);
                    opBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameGroup> yiBaoOperationNameGroups = operation.getGroups();
        for (YiBaoOperationNameGroup conflict_group : yiBaoOperationNameGroups) {
            if (NeoUtil.isExist(conflict_group)) {
                if (NeoUtil.isExist(conflict_group.getGroup())) {
                    Group group = conflict_group.getGroup();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(group.getName());
                    nodeInfo.setTypeval(Constants.group);
                    opBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNamePacsDescribe> yiBaoOperationNamePacsDescribes = operation.getPacsdescs();
        for (YiBaoOperationNamePacsDescribe yiBaoOperationNamePacsDescribe : yiBaoOperationNamePacsDescribes) {
            if (NeoUtil.isExist(yiBaoOperationNamePacsDescribe)) {
                if (NeoUtil.isExist(yiBaoOperationNamePacsDescribe.getPacsDescribe())) {
                    PacsDescribe pacsdesc = yiBaoOperationNamePacsDescribe.getPacsDescribe();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(pacsdesc.getName());
                    nodeInfo.setTypeval(Constants.pacsdesc);
                    opBillNeoDTO.getPacsDesc().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameMedAllergen> yiBaoOperationNameMedAllergens = operation.getMedallergens();
        for (YiBaoOperationNameMedAllergen yiBaoOperationNameMedAllergen : yiBaoOperationNameMedAllergens) {
            if (NeoUtil.isExist(yiBaoOperationNameMedAllergen)) {
                if (NeoUtil.isExist(yiBaoOperationNameMedAllergen.getMedAllergen())) {
                    MedAllergen medAllergen = yiBaoOperationNameMedAllergen.getMedAllergen();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(medAllergen.getName());
                    nodeInfo.setTypeval(NeoUtil.getMedType(medAllergen.getName()));
                    opBillNeoDTO.getMedallegen().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        Set<YiBaoOperationNameConflictDevice> yiBaoOperationNameConflictDevices = operation.getConflictdevices();
        for (YiBaoOperationNameConflictDevice yiBaoOperationNameConflictDevice : yiBaoOperationNameConflictDevices) {
            if (NeoUtil.isExist(yiBaoOperationNameConflictDevice)) {
                if (NeoUtil.isExist(yiBaoOperationNameConflictDevice.getConflictDevice())) {
                    ConflictDevice device = yiBaoOperationNameConflictDevice.getConflictDevice();
                    nodeInfo = new NodeInfo();
                    nodeInfo.setName(device.getName());
                    nodeInfo.setTypeval(Constants.conflictdevice);
                    opBillNeoDTO.getMeddevice().add(NeoUtil.updateNodeInfo(nodeInfo));
                }
            }
        }

        return opBillNeoDTO;
    }

    /**
     * 处理手术开单合理性
     */
    public List<BillNeoDTO> getOperationBill(List<Map<String, String>> optermlist, YiBaoOperationNameRepository opRepository) {
        List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
        BillNeoDTO billNeoDTO;

        OperationBillNeoDTO opBillNeoDTO;

        String opname;

        for (Map<String, String> opterm : optermlist) {
            for (String term : opterm.keySet()) {
                billNeoDTO = new BillNeoDTO();
                opname = opterm.get(term);
                billNeoDTO.setName(term);
                billNeoDTO.setStandname(opname);

                List<YiBaoOperationName> operations = opRepository.findByNameIs(opname);

                if (ListUtil.isNotEmpty(operations)) {
                    opBillNeoDTO = YiBaoOperationtoOperationDTO(operations.get(0));
                    billNeoDTO.setOperationBillNeoDTO(opBillNeoDTO);
                }

                billNeoDTOs.add(billNeoDTO);
            }
        }

        return billNeoDTOs;
    }

    /**
     * 获取手术操作名称列表
     */
    public List<OperationInfoDTO> getOperationList(String name, Integer size, YiBaoOperationNameRepository operationRepository, BaseNodeRepository baseNodeRepository) {
        String nodename;

        List<OperationInfoDTO> opslist = new ArrayList<>();
        OperationInfoDTO opInfoDTO;

        if (null == size) {
            size = 100;
        }

        List<YiBaoOperationName> operations = operationRepository.index(name, name, size);

        if (ListUtil.isNotEmpty(operations) && operations.size() > size) {
            operations = operations.subList(0, size);
        }

        for (YiBaoOperationName op : operations) {
            opInfoDTO = new OperationInfoDTO();
            nodename = op.getName();

            opInfoDTO.setName(nodename);
            opslist.add(opInfoDTO);
        }

        return opslist;
    }


    /**
     * 获取高危手术和操作数据
     */
    public List<HighRiskNeoDTO> getHighRiskOperation(WordCrfDTO wordCrfDTO, YiBaoOperationNameRepository operationRepository) {
        List<HighRiskNeoDTO> highRiskNeoDTOS = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO;
        String term, opname, opgrade;
        YiBaoOperationName operation;

        for (Item item : wordCrfDTO.getOperationOrder()) {
            highRiskNeoDTO = new HighRiskNeoDTO();

            term = item.getName().trim();
            opname = item.getUniqueName().trim();
            highRiskNeoDTO.setName(term);
            highRiskNeoDTO.setStandname(opname);

            List<YiBaoOperationName> operations = operationRepository.findByNameIs(opname);

            if (ListUtil.isNotEmpty(operations)) {
                operation = operations.get(0);
                if (null != operation.getOpgrade() && operation.getOpgrade().trim().length() > 0) {
                    opgrade = operation.getOpgrade().trim();
                    if (opgrade.equals("3") || opgrade.equals("4")) {
                        highRiskNeoDTO.setIsHighrisk(true);
                        highRiskNeoDTO.setHighLevel(opgrade);
                        highRiskNeoDTO.setType(Constants.shoushu);
                        highRiskNeoDTOS.add(highRiskNeoDTO);
                    } else if (opgrade.equals("2")) {
                        highRiskNeoDTO = isHighRisk(wordCrfDTO, operation, highRiskNeoDTO);
                        if (null != highRiskNeoDTO) {
                            highRiskNeoDTOS.add(highRiskNeoDTO);
                        }
                    }
                }
            }
        }

        return highRiskNeoDTOS;
    }


    /**
     * 获取手术和操作名称
     */
    public List<OperationInfoDTO> getOperationNameList(String name, Integer size, YiBaoOperationNameRepository operationRepository) {

        String nodename;

        List<OperationInfoDTO> opslist = new ArrayList<>();
        OperationInfoDTO opInfoDTO;

        if (null == size || size == 0) {
            size = Constants.termsize;
        }

        List<String> operations = operationRepository.getOperationNames(size);

        for (String opname : operations) {
            opInfoDTO = new OperationInfoDTO();
            opInfoDTO.setName(opname);
            opslist.add(opInfoDTO);
        }

        return opslist;
    }


    public HighRiskNeoDTO isHighRisk(WordCrfDTO wordCrfDTO, YiBaoOperationName operation, HighRiskNeoDTO highRiskNeoDTO) {

        NodeNeoDTO nodeNeoDTO;
        Boolean match;
        Map<String, Object> res;

        try {
            String cond = operation.getHighriskcond();
            JSONObject jobj = JSONObject.parseObject(cond);

            if (null!=jobj) {
                // 判断年龄
                JSONObject ageobj = jobj.getJSONObject("年龄");

                nodeNeoDTO = NeoUtil.jsontoNodeNeoDTO("年龄", ageobj);
                if (null != wordCrfDTO.getAgeNum()) {
                    double age = wordCrfDTO.getAgeNum();
                    match = CoreUtil.compareNum(nodeNeoDTO, age);
                    if (match) {
                        nodeNeoDTO.setName("年龄:" + CoreUtil.subZeroAndDot(String.valueOf(age)));
                        nodeNeoDTO.setVal("年龄:" + CoreUtil.subZeroAndDot(String.valueOf(age)));
                        nodeNeoDTO.setTermtype(TypeEnum.age.getName());
                        highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                    }
                }

                // 判断生命体征和查体
                VitalLabel vitalLabel = wordCrfDTO.getVitalLabel();
                JSONObject vitalobj = jobj.getJSONObject("生命体征及查体");
                for (String key : vitalobj.keySet()) {
                    nodeNeoDTO = NeoUtil.jsontoNodeNeoDTO(key, vitalobj.getJSONObject(key));
                    res = CoreUtil.compareVital(nodeNeoDTO, vitalLabel);

                    if ((Boolean) res.get("flag")) {
                        nodeNeoDTO.setVal(res.get("msg").toString());
                        nodeNeoDTO.setTermtype(TypeEnum.vital.getName());
                        highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                    }
                }

                // 判断合并疾病
                List<Item> diags = wordCrfDTO.getDiag();
                JSONObject diagobj = jobj.getJSONObject("合并疾病");
                for (String key : diagobj.keySet()) {
                    for (Item item : diags) {
                        if (StringUtil.isNotBlank(item.getUniqueName()) && item.getUniqueName().equals(key)) {
                            nodeNeoDTO = new NodeNeoDTO();
                            nodeNeoDTO.setName(item.getUniqueName());
                            nodeNeoDTO.setVal(item.getName());
                            nodeNeoDTO.setTermtype(TypeEnum.disease.getName());
                            highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                        }
                    }
                }

                // 判断化验结果
                List<com.diagbot.biz.push.entity.Lis> lislist = wordCrfDTO.getLis();
                JSONObject lisobj = jobj.getJSONObject("化验结果");
                for (String key : lisobj.keySet()) {
                    nodeNeoDTO = NeoUtil.jsontoNodeNeoDTO(key, lisobj.getJSONObject(key));
                    for (com.diagbot.biz.push.entity.Lis lis : lislist) {
                        String name = lis.getUniqueName();
                        if (nodeNeoDTO.getName().equals(name)) {
                            res = CoreUtil.compareLis(nodeNeoDTO, lis);

                            if ((Boolean) res.get("flag")) {
                                nodeNeoDTO.setVal(res.get("msg").toString());
                                nodeNeoDTO.setTermtype(TypeEnum.lis.getName());
                                highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                            }
                        }
                    }
                }

                // 判断辅检结果
                PacsLabel pacslbl = wordCrfDTO.getPacsLabel();

                JSONObject pacsobj = jobj.getJSONObject("辅检结果描述");
                for (String key : pacsobj.keySet()) {

                    for (Item item : pacslbl.getRes()) {
                        if (StringUtil.isNotBlank(item.getUniqueName()) && item.getUniqueName().contains(key)) {
                            nodeNeoDTO = new NodeNeoDTO();
                            nodeNeoDTO.setName(item.getUniqueName());
                            nodeNeoDTO.setVal(item.getUniqueName());
                            nodeNeoDTO.setTermtype(TypeEnum.pacs.getName());
                            highRiskNeoDTO.getFactor().add(nodeNeoDTO);
                        }
                    }
                }

                if (highRiskNeoDTO.getFactor().size() > 0) {
                    highRiskNeoDTO.setType(TypeEnum.operation.getName());
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            return highRiskNeoDTO;
        }

    }


}
