package com.diagbot.rule;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.CriticalNeoDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.enums.TypeEnum;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.MsgUtil;
import com.diagbot.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @description: 化验规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
@Component
public class LisRule {

    /**
     * 比较化验——开单合理性
     *
     * @param inputLis
     * @param billNeoMaxDTO
     * @return
     */
    public void bill(List<Lis> inputLis, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getLis();
        if(ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLis)){
            for (NodeNeoDTO neo : neoList) {
                for (Lis lis : inputLis) {
                    String val = lis.getUniqueName();
                    if (StringUtil.isNotBlank(val) && val.equals(neo.getName())) {
                        Map<String, Object> map = CoreUtil.compareLis(neo, lis);
                        if ((Boolean) map.get("flag") == true) {
                            BillMsg commonBillMsg = MsgUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),
                                    billNeoMaxDTO.getOrderStandName(), (String)map.get("msg"), type, billNeoMaxDTO.getType());
                            billMsgList.add(commonBillMsg);
                        }
                    }
                }
            }
        }
    }

    /**
     * 比较化验——危急值
     *
     * @param wordCrfDTO
     * @param critical
     */
    public void critical(WordCrfDTO wordCrfDTO, CriticalNeoDTO critical, List<BillMsg> criticalList) {
        List<Lis> lisList = wordCrfDTO.getLis();
        NodeNeoDTO nodeNeoDTO = critical.getCritical();
        for (Lis bean : lisList) {
            if (critical.getStandname().equals(bean.getUniqueName())) {
                Map<String, Object> map = CoreUtil.compareLis(nodeNeoDTO, bean);
                if ((Boolean) map.get("flag") == true) {
                    BillMsg criticalMsg = MsgUtil.getCommonCriticalMsg((String) map.get("msg"), TypeEnum.lis.getName());
                    criticalList.add(criticalMsg);
                }
            }
        }
    }
}
