package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.model.label.VitalLabel;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.MsgUtil;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @description: 体征规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
@Component
public class VitalRule {

    /**
     * 比较体征
     *
     * @param vitalLabel
     * @param billNeoMaxDTO
     * @param billMsgList
     * @param type 类型
     * @return
     */
    public void bill(VitalLabel vitalLabel, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getVitals();
        if(ListUtil.isNotEmpty(neoList)){
            for (NodeNeoDTO neo : neoList) {
                Map<String, Object> map = CoreUtil.compareVital(neo, vitalLabel);
                if ((Boolean) map.get("flag") == true) {
                    BillMsg commonBillMsg = MsgUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),
                            billNeoMaxDTO.getOrderStandName(), (String) map.get("msg"), type, billNeoMaxDTO.getType());
                    billMsgList.add(commonBillMsg);
                }
            }
        }
    }
}
